HDU

来源:互联网 发布:勇敢的心 手游 知乎 编辑:程序博客网 时间:2024/06/06 08:34

题目:
FatMouse has stored some cheese in a city. The city can be considered as a square grid of dimension n: each grid location is labelled (p,q) where 0 <= p < n and 0 <= q < n. At each grid location Fatmouse has hid between 0 and 100 blocks of cheese in a hole. Now he’s going to enjoy his favorite food.

FatMouse begins by standing at location (0,0). He eats up the cheese where he stands and then runs either horizontally or vertically to another location. The problem is that there is a super Cat named Top Killer sitting near his hole, so each time he can run at most k locations to get into the hole before being caught by Top Killer. What is worse – after eating up the cheese at one location, FatMouse gets fatter. So in order to gain enough energy for his next run, he has to run to a location which have more blocks of cheese than those that were at the current hole.

Given n, k, and the number of blocks of cheese at each grid location, compute the maximum amount of cheese FatMouse can eat before being unable to move.
Input
There are several test cases. Each test case consists of

a line containing two integers between 1 and 100: n and k
n lines, each with n numbers: the first line contains the number of blocks of cheese at locations (0,0) (0,1) … (0,n-1); the next line contains the number of blocks of cheese at locations (1,0), (1,1), … (1,n-1), and so on.
The input ends with a pair of -1’s.
Output
For each test case output in a line the single integer giving the number of blocks of cheese collected.
Sample Input
3 1
1 2 5
10 11 6
12 12 7
-1 -1
Sample Output
37

题目大意:
每个位置都有值,初始位置在(0,0),在任意位置只能往4个方向移动,而且最多只能移动k位,而且每次拿到的值必须比上一次大,相等都不行,问在不能移动之前,一共可以取多少值。

思路:
dp,由于是求从(0,0)出发的,所以我的dp[i][j] 定义的是从(i,j)出发,能拿到的最大的值。
所以有状态转移: dp[i][j] = max(dp[chi][chj])+data[i][j]; 而且data[i][j] < data[chi][chj],(chi,chj)是(i,j)可以移动到的位置。
由于拿值的顺序是会影响到最终的结果的,所以我们需要把值从小到大排序,而且由于我是用(i,j)做起点而不是终点,所以顺序是从最后一个向前枚举。
id[i][j] 表示(i,j)在data中排完序后的下标。

代码:

#include <cstdio>#include <cstring>#include <iostream>#include <algorithm>using namespace std;const int maxn = 105;int dp[maxn][maxn];int id[maxn][maxn];int d[maxn][maxn];struct node{    int w,x,y;}data[maxn*maxn];int cmp(node a,node b){    return a.w < b.w;}int n,k;int main(){    while(~scanf("%d%d",&n,&k))    {        if(n == -1 && k == -1) break;        //memset(dp,0,sizeof(dp));        for(int i = 0; i < n ; i++)        {            for(int j = 0; j < n; j++)            {                scanf("%d",&d[i][j]);                data[i*n + j].w = d[i][j];                data[i*n+j].x = i, data[i*n+j].y = j;            }        }        sort(data,data+n*n,cmp);        for(int i = 0; i < n*n; i++)            id[data[i].x][data[i].y] = i;        dp[data[n*n-1].x][data[n*n-1].y] = data[n*n-1].w;        for(int i = n*n-2; i >= 0; i--)        {            int res = data[i].w;            int ix = data[i].x,iy = data[i].y;            for(int j = ix-k; j <= ix+k; j++)            {                if(j < 0 || j >= n || j == ix) continue;                if(d[j][iy] > d[ix][iy])                    res = max(res,dp[j][iy] + data[i].w);            }            for(int j = iy-k; j<=iy+k; j++)            {                if(j < 0 || j >= n || j == iy) continue;                if(d[ix][j] > d[ix][iy])                    res = max(res,dp[ix][j] + data[i].w);            }            dp[ix][iy] = res;        }        printf("%d\n",dp[0][0]);    }    return 0;}
0 0
原创粉丝点击